#!/usr/bin/env python3

import serial
#import time
import struct

def hosh(byte, nbit, CRC):
	for i in range(0, nbit):
		if (byte ^ (CRC >> 8)) & 0x80:
			CRC <<=1
			CRC %= 65536
			CRC ^=0x8f57
		else:
			CRC <<=1
			CRC %= 65536
		byte <<= 1
		byte %= 256
	return CRC

def hosh_full(arr):
        crc = 0
        for a in arr:
                crc = hosh(a, 8, crc)
        return (crc // 256, crc % 256)
        
"""
def bla(ch):
	if ch == 'G':
		return 0
	elif ch == 'H':
		return 1
	elif ch == 'I':
		return 2
	elif ch == 'J':
		return 3
	elif ch == 'K':
		return 4
	elif ch == 'L':
		return 5
	elif ch == 'M':
		return 6
	elif ch == 'N':
		return 7
	elif ch == 'O':
		return 8
	elif ch == 'P':
		return 9
	elif ch == 'Q':
		return 10
	elif ch == 'R':
		return 11
	elif ch == 'S':
		return 12
	elif ch == 'T':
		return 13
	elif ch == 'U':
		return 14
	elif ch == 'V':
		return 15

def blaObr(byte):
	if byte == 0:
		return 'G'
	elif byte == 1:
		return 'H'
	elif byte == 2:
		return 'I'
	elif byte == 3:
		return 'J'
	elif byte == 4:
		return 'K'
	elif byte == 5:
		return 'L'
	elif byte == 6:
		return 'M'
	elif byte == 7:
		return 'N'
	elif byte == 8:
		return 'O'
	elif byte == 9:
		return 'P'
	elif byte == 10:
		return 'Q'
	elif byte == 11:
		return 'R'
	elif byte == 12:
		return 'S'
	elif byte == 13:
		return 'T'
	elif byte == 14:
		return 'U'
	elif byte == 15:
		return 'V'
"""

def blaObr2(byte):
        return (0x47 + byte)

def bla2(ch):
        return int(-0x47 + ch)




def tet2byte(st):
        m = []
        if st[0] == ord('#'):
                i = 1
        else:
                i = 0

        #print(st)
        while st[i] != 13 :
                #print(st[i], st[i + 1])
                r = int(bla2((st[i]))) * 16 + int(bla2(st[i + 1]))
                i += 2
                m += [r]
        return m

def byte2tet(m):
        st = [ord('#')]
        for x in m:
                #print(blaObr2(x // 16))
                #print(blaObr2(x % 16))
                st += [blaObr2(x // 16)]
                st += [blaObr2(x % 16)]
        st += [ord('\r')]
        return st

def fourb2float(arr):
        bu = bytes(arr)
        return struct.unpack('f', bu)

class UKT38():
        def __init__(self, serName):
                try:
                        self.ser = serial.Serial(serName, timeout = 1)
                        self.ER = False
                except:
                        #print('ER')
                        self.ER = True
                
        def getKvit(self, channel, tud):
                try:
                        channel += 16
                        #ser = serial.Serial(ser, timeout = 1)
                        ser = self.ser
                        #print(ser)
                        m = [channel]
                        m += [0b00010000]
                        #print(m)
                        #print(bla2())
                        if tud == 0:
                                m += [0xb8, 0xdf]
                        elif tud == 1:
                                m += [0xd7, 0x13]
                        elif tud == 2:
                                m += [0xf5, 0x80]
                        else:
                                return (0, 'Wrong tud')
                        h = hosh_full(m)
                        m += [h[0], h[1]]
                        zap = byte2tet(m)
                        #print(zap)
        
        
                        b = bytes(zap)
                        g = ser.write(b)
                        #print(b)
                        otv = ser.readline()
                        #print(otv)
                        if len(otv) == 0:
                                return 'Er'
        
                        otv2 = []
                        for df in otv:
                                otv2 += [int(df)]
                        otv = otv2
                      #  st = []
                       # for o in otv:
                        #        st += []
                        m = tet2byte(otv)
        
       # if otv[0] != channel:
          # or len(otv) != 10:
        #  return (0, 'Wrong answer')
                #print(m)
                        mm = [m[7], m[6], m[5], m[4]]
                        f2f = fourb2float(mm)
                        if f2f[0] < -300:
                                return 0
                        else:
                                return f2f[0]
                except:
                        return 'Er'


def findUkt(index):
        for i in range(0, 20):
                if i in index:
                        continue
                u = UKT38('/dev/ttyUSB' + str(i))
                if u.ER != True:
                        a = u.getKvit(2, 0)
                        if a != 'Er':
                                #print(a)
                                #time.sleep(1)
                                return (u, i)
        return None
                
